#!/usr/bin/tclh.static
#
# $FreeBSD: libh/bin/setup/setup.tcl,v 1.2 2000/09/09 15:33:28 alex Exp $

set H_automatic_garbage_collection 0
set H_VERSION 0

set hui_type "auto"

# Init UI
set hui [Hui::open $hui_type]

proc next_callback {hui button user_data} {
	# receive next files via File::Fetch, if needed, close this UI
	# and execute the next script
	$hui exit
}

proc quit_callback {hui button user_data} {
	exit 0
}

proc cat_box_select_callback {hui widget id user_data} {
	set package_box [H::call $hui byName "package_box"]
	$package_box removeAll
	$package_box add 0 [format "Packages of category: %s" [$widget text $id]]
}

# Create the main-window and its elements
proc make_main_win {hui} {
	global main_window

	# Create a main_window with title, x/y offset and x/y size
	set main_window [$hui window main_window "FreeBSD Setup" "14 0" "50 20"] 
	set welcometext [$main_window textEdit welcometext "Welcome to FreeBSD!

This program will guide you through the
installation of FreeBSD.

foo bar baz

Please press 'Next' to receive the next files
and continue with the installation,
or 'Quit' to quit setup of FreeBSD." FALSE]

	set next_button [$main_window button "inst_button" "&Next ->" {next_callback ""}]
	set quit_button [$main_window button "uninst_button" "&Quit" {quit_callback ""}]

	$welcometext resize "48 17"
	$quit_button resize "11 2"
	$next_button move "26 17"
	$quit_button move "37 17"
	$next_button resize "11 2"

	# Finally, show the window
	$main_window show

}

# Create the main-window
make_main_win $hui

# Run hui
$hui run
