#!/usr/local/bin/tclsh8.3
#
# $FreeBSD: libh/doc/examples/hello_world.tcl,v 1.4 2001/06/17 12:48:25 alex Exp $

set H_automatic_garbage_collection 0
set H_VERSION 0

set hui_type "auto"
if {[info exists argc]} {
        if {$argc > 0} {
                set tmp_type [lindex $argv 0]
                if {$tmp_type == "graphics" || $tmp_type == "text"} {
                        set hui_type [lindex $argv 0]
                } else {
                        puts stderr "Invalid UI-type, sticking with auto."
                        puts stderr "Try `text' or `graphics' next time.\n"
                }
        }
}

# ----------------------------------------------------------------------

load ../../lib/common/libh.so.$H_VERSION
load ../../lib/tcl/libhtcl.so.$H_VERSION
load ../../lib/file/libhfile.so.$H_VERSION
load ../../lib/hui/libhui.so.$H_VERSION
load ../../lib/tcl/libhtclhui.so.$H_VERSION

# ----------------------------------------------------------------------

# Create the main-window and its elements
proc make_main_win {hui} {
	global main_window

	# Create a main_window with title, x/y offset and x/y size
	set main_window [$hui window main_window "Hello World in libh" "0 0" "25 5" "vertical"] 

	# Define the widget we want to add
	set widget1 [$main_window textEdit "text_edit1" "Hello World!" FALSE]

	# Finally, show the window
	$main_window show
}

# Init UI
set hui [Hui::open $hui_type]

# Create the main-window
make_main_win $hui

# Run hui
$hui run
