#!/usr/local/bin/tclsh8.3
#
# $FreeBSD: libh/doc/examples/packageman.tcl,v 1.5 2001/06/17 12:51:03 alex Exp $

set H_automatic_garbage_collection 0
set H_VERSION 0

set hui_type "auto"
if {[info exists argc]} {
        if {$argc > 0} {
                set tmp_type [lindex $argv 0]
                if {$tmp_type == "graphics" || $tmp_type == "text"} {
                        set hui_type [lindex $argv 0]
                } else {
                        puts stderr "Invalid UI-type, sticking with auto."
                        puts stderr "Try `text' or `graphics' next time.\n"
                }
        }
}

# ----------------------------------------------------------------------

load ../../lib/common/libh.so.$H_VERSION
load ../../lib/tcl/libhtcl.so.$H_VERSION

load ../../lib/file/libhfile.so.$H_VERSION
load ../../lib/hui/libhui.so.$H_VERSION
load ../../lib/tcl/libhtclhui.so.$H_VERSION

# ----------------------------------------------------------------------

# Init UI
set hui [Hui::open $hui_type]

proc inst_callback {hui button user_data} {
	set package_box [H::call $hui byName "package_box"]
	puts [format "Installing Package: %s" [$package_box text [$package_box select]]]
}

proc uninst_callback {hui button user_data} {
}

proc quit_callback {hui button user_data} {
	$hui exit 0
	exit 0
}

proc cat_box_select_callback {hui widget id user_data} {
	set package_box [H::call $hui byName "package_box"]
	$package_box removeAll
	$package_box add 0 [format "Packages of category: %s" [$widget text $id]]
}

# Create the main-window and its elements
proc make_main_win {hui} {
	global main_window

	# Create a main_window with title, x/y offset and x/y size
	set main_window [$hui window main_window "FreeBSD Package manager" "0 0" "50 20" "horizontal"] 

	set cat_box [$main_window listBox "cat_box" {} -1 "Package &Categories"]
	set vcontainer [$main_window container "vcontainer" "" "vertical"]
	
	set package_box [$vcontainer listBox "package_box" {} -1 "Package &List"]

	set bcontainer [$vcontainer container "bcontainer" "" "horizontal"]

	set inst_button [$bcontainer button "inst_button" "&Install" {inst_callback ""}]
	set uninst_button [$bcontainer button "uninst_button" "&Uninstall" {uninst_callback ""}]
	set quit_button [$bcontainer button "quit_button" "&Quit" {quit_callback ""}]

	$bcontainer resize "-1 3"
	# Finally, show the window
	$main_window show
}


# Create the main-window
make_main_win $hui
set cat_box [H::call $hui byName "cat_box"]
[$main_window byName "cat_box"] onSelect {cat_box_select_callback click}

$cat_box add 0 "test1" 
$cat_box add 1 "test2" 
$cat_box add 2 "test3" 
$cat_box select 1

# Run hui
$hui run
