#!/usr/local/bin/tclsh8.3
#
# $FreeBSD: libh/doc/examples/simple_button.tcl,v 1.4 2000/10/13 19:00:07 alex Exp $

set H_automatic_garbage_collection 0
set H_VERSION 0
set hui_type "auto"

# ----------------------------------------------------------------------

load ../../lib/common/libh.so.$H_VERSION
load ../../lib/tcl/libhtcl.so.$H_VERSION
load ../../lib/file/libhfile.so.$H_VERSION
load ../../lib/hui/libhui.so.$H_VERSION
load ../../lib/tcl/libhtclhui.so.$H_VERSION

# ----------------------------------------------------------------------

# Button Callback Function
proc button_callback {bar baz foo} {
	exit 0
}

# Create the main-window and its elements
proc make_main_win {hui} {
	global main_window

	# Create a main_window with title, x/y offset and x/y size
	set main_window [$hui window main_window "FreeBSD Graphical UI using libh" "0 0" "50 10" "vertical"] 

	# childs of window
	set container [$main_window container "container1" "" "horizontal"]
	set button_widget1 [$main_window button "button_widget1" "I'm button 1 (exits)" {button_callback ""}]

	# childs of container
	set button_widget2 [$container button "button_widget2" "Hello, this is button 2 (version two)" {button_callback ""}]
	set button_widget3 [$container button "button_widget3" "Click button 3!!!" {button_callback ""}]
	set button_widget4 [$container button "button_widget4" "button 4..." {button_callback ""}]

	# Finally, show the window
	$main_window show
}

proc show_about {} {

}

# Init UI
set hui [Hui::open $hui_type]

# Create the main-window
make_main_win $hui

# Run hui
$hui run

