/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/common/H.cd.cc,v 1.5 2001/06/20 10:06:26 alex Exp $
 */

// -*- C++ -*-   Tue Dec  8 1998
// Eugene Skepner <eu@qub.com>
// $Id: H.cd.cc,v 1.1.1.1 2000/02/15 16:30:34 alex Exp $

#ifndef H_hh
#include "H.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription HObjectsReferences::sMethods[] =
{
	MethodDescription("release",
			  "release",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Removes language interface for the objects created and not removed since creating of this object (and probably removes these objects from the memory)",
			  MethodDescription::vtVoid,
			  MethodDescription::vtVoid),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HObjectsReferences::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HObjectsReferences::sClassDescription(
	"HObjectsReferences",
	"HObjectsReferences",
	"Language Interface non-AGC objects management",
	sMethods,
	sCallbacks
);

//======================================================================

LanguageInterface::Object::MethodDescription H::sMethods[] =
{
	MethodDescription("delete",
			  "dereference",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Removes language interface for the specified objects (and probably removes these objects from the memory)",
			  MethodDescription::vtVoid,
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtList,
						   "list<Pointer<LanguageInterface::Object> >",
						   "list<Pointer<LanguageInterface::Object> >()"),
			  MethodDescription::Value(MethodDescription::vtLanguageInterface,
						   0,
						   "0")),
	MethodDescription("null",
			  "null",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns NULL object",
			  MethodDescription::vtObject,
			  MethodDescription::vtVoid),
	MethodDescription("is_null",
			  "is_null",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns if an object is NULL",
			  MethodDescription::vtBool,
			  MethodDescription::vtObject),
	MethodDescription("not_null",
			  "not_null",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns if an object is not NULL",
			  MethodDescription::vtBool,
			  MethodDescription::vtObject),
	MethodDescription("as_string",
			  "as_string",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns string representation of an object",
			  MethodDescription::vtString,
			  MethodDescription::vtObject),
	MethodDescription("objects_references",
			  "objects_references",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns on-AGC objects manager",
			  MethodDescription::vtObject,
			  MethodDescription::Value(MethodDescription::vtLanguageInterface,
						   0,
						   "0")),
	MethodDescription("string_time_t",
			  "string_time_t",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns string representation of time_t value",
			  MethodDescription::vtString,
			  MethodDescription::vtULong),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription H::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription H::sClassDescription(
	"H",
	"H",
	"Language Interface management methods",
	sMethods,
	sCallbacks
);

//======================================================================
