/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/common/Log.cd.cc,v 1.5 2001/06/20 10:06:27 alex Exp $
 */

// -*- C++ -*-   Sat Jan 16 1999
// Eugene Skepner <eu@qub.com>
// $Id: Log.cd.cc,v 1.1.1.1 2000/02/15 16:30:34 alex Exp $

#ifndef Log_hh
#include "Log.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription Log::sMethods[] =
{
	MethodDescription("Log",
			  "instance",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Possibly creates and retuns log object instance",
			  MethodDescription::Value(MethodDescription::vtObject,
						   "Log"),
			  MethodDescription::vtVoid ),
	MethodDescription("text",
			  "text",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Returns log contents",
			  MethodDescription::vtString,
			  MethodDescription::vtVoid),
	MethodDescription("type",
			  "type",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Sets log type",
			  MethodDescription::vtVoid,
			  MethodDescription::Value(MethodDescription::vtString,
						   0,
						   0,
						   "type")),
	MethodDescription("gettype",
			  "type",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Gets log type",
			  MethodDescription::vtString,
			  MethodDescription::vtVoid),
	MethodDescription("clear",
			  "clear",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Clears log",
			  MethodDescription::vtVoid, MethodDescription::vtVoid),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription Log::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription Log::sClassDescription(
	"Log",
	"Log",
	"Log Interface",
	sMethods,
	sCallbacks
);

//======================================================================

LanguageInterface::Object::MethodDescription LogStderr::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription LogStderr::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription LogStderr::sClassDescription(
	"LogStderr",
	"LogStderr",
	"LogStderr Interface",
	sMethods,
	sCallbacks,
	Log::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription LogString::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription LogString::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription LogString::sClassDescription(
	"LogString",
	"LogString",
	"LogString Interface",
	sMethods,
	sCallbacks,
	Log::thisClassDescription()
);

//======================================================================
