/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/common/ProgressIndicator.cd.cc,v 1.5 2001/06/20 10:06:27 alex Exp $
 */

// -*- C++ -*-   Sun Jan  3 1999
// Eugene Skepner <eu@qub.com>
// $Id: ProgressIndicator.cd.cc,v 1.1.1.1 2000/02/15 16:30:34 alex Exp $

#ifndef ProgressIndicator_hh
#include "ProgressIndicator.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription ProgressIndicatorStack::sMethods[] =
{
	MethodDescription("ProgressIndicatorStack",
			  "make",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns newly created ProgressIndicatorStack object",
			  MethodDescription::Value(MethodDescription::vtObject,
						   "ProgressIndicatorStack"),
			  MethodDescription::vtVoid),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription ProgressIndicatorStack::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription ProgressIndicatorStack::sClassDescription(
	"ProgressIndicatorStack",
	"ProgressIndicatorStack",
	"ProgressIndicatorStack interface",
	sMethods,
	sCallbacks
);

//======================================================================

LanguageInterface::Object::MethodDescription ProgressIndicatorStreamStack::sMethods[] =
{
	MethodDescription("ProgressIndicatorStreamStack",
			  "make",
			  LanguageInterface::Object::MethodDescription::fStatic,
			  "Returns newly created ProgressIndicatorStreamStack object",
			  MethodDescription::Value(MethodDescription::vtObject,
						   "ProgressIndicatorStack"),
			  MethodDescription::vtVoid),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription ProgressIndicatorStreamStack::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription ProgressIndicatorStreamStack::sClassDescription(
	"ProgressIndicatorStreamStack",
	"ProgressIndicatorStreamStack",
	"ProgressIndicatorStreamStack interface",
	sMethods,
	sCallbacks,
	ProgressIndicatorStack::thisClassDescription()
);

//======================================================================
