/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/file/DirectoriesAccess.cd.cc,v 1.4 2001/06/20 10:10:30 alex Exp $
 */

// -*- C++ -*-   Wed Dec 23 1998
// Eugene Skepner <eu@qub.com>
// $Id: DirectoriesAccess.cd.cc,v 1.1.1.1 2000/02/15 16:30:34 alex Exp $

#ifndef DirectoriesAccess_hh
#include "DirectoriesAccess.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription DirectoriesAccess::sMethods[] =
{
	MethodDescription( "DirectoriesAccess", "instance",
				LanguageInterface::Object::MethodDescription::fStatic,
				"Interface to DirectoriesAccess",
				MethodDescription::Value( MethodDescription::vtObject, "DirectoriesAccess" ), MethodDescription::vtVoid ),
	MethodDescription( "accessAllowed", "accessAllowed",
				LanguageInterface::Object::MethodDescription::fDynamic,
				"Returns if access is allowed to the specified directory",
				MethodDescription::vtBool, MethodDescription::Value( MethodDescription::vtString, 0, 0, "dir" ) ),
	MethodDescription( "deny", "deny",
				LanguageInterface::Object::MethodDescription::fDynamic | LanguageInterface::Object::MethodDescription::fSafeExecution | LanguageInterface::Object::MethodDescription::fGetOrSet,
				"Sets or gets list of directories access is denied to",
				MethodDescription::Value( MethodDescription::vtListRef, "DirectoriesAccess::List" ), MethodDescription::Value( MethodDescription::vtList, "DirectoriesAccess::List", "get-or-set", "denied_dirs" ) ),
	MethodDescription( "allow", "allow",
				LanguageInterface::Object::MethodDescription::fDynamic | LanguageInterface::Object::MethodDescription::fSafeExecution | LanguageInterface::Object::MethodDescription::fGetOrSet,
				"Sets or gets list of directories access is allowed to",
				MethodDescription::Value( MethodDescription::vtListRef, "DirectoriesAccess::List" ), MethodDescription::Value( MethodDescription::vtList, "DirectoriesAccess::List", "get-or-set", "allowed_dirs" ) ),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription DirectoriesAccess::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription DirectoriesAccess::sClassDescription(
	"DirectoriesAccess", "DirectoriesAccess",
	"Information about allowed access to directories",
	sMethods,
	sCallbacks
);

//======================================================================
