/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/hui/HuiQt.cd.cc,v 1.7 2001/06/20 10:24:45 alex Exp $
 */

// -*- C++ -*-   Tue Dec  8 1998
// Eugene Skepner <eu@qub.com>
// $Id: HuiQt.cd.cc,v 1.1.1.1 2000/02/15 16:30:35 alex Exp $

#ifndef HuiQt_hh
#include "HuiQt.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::sClassDescription(
	"HuiQt",
	"HuiQt",
	"Qt based user iterface",
	sMethods,
	sCallbacks,
	Hui::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::Widget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::Widget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::Widget::sClassDescription(
	"HuiQt::Widget",
	"HuiQt::Widget",
	"",
	sMethods,
	sCallbacks,
	Hui::Widget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::ContainerWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::ContainerWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::ContainerWidget::sClassDescription(
	"HuiQt::ContainerWidget",
	"HuiQt::ContainerWidget",
	"",
	sMethods,
	sCallbacks,
	Hui::ContainerWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::GroupWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::GroupWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::GroupWidget::sClassDescription(
	"HuiQt::GroupWidget",
	"HuiQt::GroupWidget",
	"",
	sMethods,
	sCallbacks,
	Hui::GroupWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::ToplevelWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::ToplevelWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::ToplevelWidget::sClassDescription(
	"HuiQt::ToplevelWidget",
	"HuiQt::ToplevelWidget",
	"",
	sMethods,
	sCallbacks,
	Hui::ToplevelWidget::thisClassDescription(),
	HuiQt::GroupWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::WindowWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::WindowWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::WindowWidget::sClassDescription(
	"HuiQt::WindowWidget",
	"HuiQt::WindowWidget",
	"",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription(),
	HuiQt::ToplevelWidget::thisClassDescription(),
	Hui::WindowWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::DialogWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::DialogWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::DialogWidget::sClassDescription(
	"HuiQt::DialogWidget",
	"HuiQt::DialogWidget",
	"",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription(),
	HuiQt::ToplevelWidget::thisClassDescription(),
	Hui::DialogWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::LabelWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::LabelWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::LabelWidget::sClassDescription(
	"HuiQt::LabelWidget",
	"HuiQt::LabelWidget",
	"Widget for displaying a static text",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription(),
	Hui::LabelWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::ButtonWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::ButtonWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::ButtonWidget::sClassDescription(
	"HuiQt::ButtonWidget",
	"HuiQt::ButtonWidget",
	"Push button with a text",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription(),
	Hui::ButtonWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::TitledWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::TitledWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::TitledWidget::sClassDescription(
	"HuiQt::TitledWidget",
	"HuiQt::TitledWidget",
	"Base class for widgets having label",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::InputLineWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::InputLineWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::InputLineWidget::sClassDescription(
	"HuiQt::InputLineWidget",
	"HuiQt::InputLineWidget",
	"Simple line editor for inputting text with some validation",
	sMethods,
	sCallbacks,
	HuiQt::TitledWidget::thisClassDescription(),
	Hui::InputLineWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::ButtonsGroupWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::ButtonsGroupWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::ButtonsGroupWidget::sClassDescription(
	"HuiQt::ButtonsGroupWidget",
	"HuiQt::ButtonsGroupWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription(),
	Hui::ButtonsGroupWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::CheckBoxesWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::CheckBoxesWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::CheckBoxesWidget::sClassDescription(
	"HuiQt::CheckBoxesWidget",
	"HuiQt::CheckBoxesWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiQt::ButtonsGroupWidget::thisClassDescription(),
	Hui::CheckBoxesWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::RadioMenuWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::RadioMenuWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::RadioMenuWidget::sClassDescription(
	"HuiQt::RadioMenuWidget",
	"HuiQt::RadioMenuWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiQt::ButtonsGroupWidget::thisClassDescription(),
	Hui::RadioMenuWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::ListBoxWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::ListBoxWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::ListBoxWidget::sClassDescription(
	"HuiQt::ListBoxWidget",
	"HuiQt::ListBoxWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiQt::TitledWidget::thisClassDescription(),
	Hui::ListBoxWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::TextEditWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::TextEditWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::TextEditWidget::sClassDescription(
	"HuiQt::TextEditWidget",
	"HuiQt::TextEditWidget",
	"Simple editor for inputting text",
	sMethods,
	sCallbacks,
	HuiQt::TitledWidget::thisClassDescription(),
	Hui::TextEditWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::ProgressIndicatorWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::ProgressIndicatorWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::ProgressIndicatorWidget::sClassDescription(
	"HuiQt::ProgressIndicatorWidget",
	"HuiQt::ProgressIndicatorWidget",
	"Horizontal progress bar",
	sMethods,
	sCallbacks,
	HuiQt::TitledWidget::thisClassDescription(),
	Hui::ProgressIndicatorWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::MenuItemWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::MenuItemWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::MenuItemWidget::sClassDescription(
	"HuiQt::MenuItemWidget",
	"HuiQt::MenuItemWidget",
	"Menu Item base class",
	sMethods,
	sCallbacks,
	HuiQt::Widget::thisClassDescription(),
	Hui::MenuItemWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::MenuSeparatorWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::MenuSeparatorWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::MenuSeparatorWidget::sClassDescription(
	"HuiQt::MenuSeparatorWidget",
	"HuiQt::MenuSeparatorWidget",
	"Menu Separator",
	sMethods,
	sCallbacks,
	HuiQt::MenuItemWidget::thisClassDescription(),
	Hui::MenuSeparatorWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::MenuButtonWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::MenuButtonWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::MenuButtonWidget::sClassDescription(
	"HuiQt::MenuButtonWidget",
	"HuiQt::MenuButtonWidget",
	"Menu Button",
	sMethods,
	sCallbacks,
	HuiQt::MenuItemWidget::thisClassDescription(),
	Hui::MenuButtonWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::MenuSubmenuWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::MenuSubmenuWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::MenuSubmenuWidget::sClassDescription(
	"HuiQt::MenuSubmenuWidget",
	"HuiQt::MenuSubmenuWidget",
	"Menu Submenu",
	sMethods,
	sCallbacks,
	HuiQt::MenuItemWidget::thisClassDescription(),
	Hui::MenuSubmenuWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiQt::MenuBarWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiQt::MenuBarWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiQt::MenuBarWidget::sClassDescription(
	"HuiQt::MenuBarWidget",
	"HuiQt::MenuBarWidget",
	"Menu Bar",
	sMethods,
	sCallbacks,
	HuiQt::MenuSubmenuWidget::thisClassDescription()
);

//======================================================================
