/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/hui/HuiTVision.cd.cc,v 1.6 2001/06/20 10:24:48 alex Exp $
 */

// -*- C++ -*-   Tue Dec  8 1998
// Eugene Skepner <eu@qub.com>
// $Id: HuiTVision.cd.cc,v 1.1.1.1 2000/02/15 16:30:35 alex Exp $

#ifndef HuiTVision_hh
#include "HuiTVision.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::sClassDescription(
	"HuiTVision",
	"HuiTVision",
	"TVision based user iterface",
	sMethods,
	sCallbacks,
	Hui::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::Widget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::Widget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::Widget::sClassDescription(
	"HuiTVision::Widget",
	"HuiTVision::Widget",
	"",
	sMethods,
	sCallbacks,
	Hui::Widget::thisClassDescription()
);

//======================================================================
LanguageInterface::Object::MethodDescription HuiTVision::ContainerWidget::sMethods[] =
{
        MethodDescription()
};      

LanguageInterface::Object::CallbackDescription HuiTVision::ContainerWidget::sCallbacks[] =
{
        CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::ContainerWidget::sClassDescription(
        "HuiTVision::ContainerWidget",
        "HuiTVision::ContainerWidget",
        "",
        sMethods,
        sCallbacks,
        Hui::ContainerWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::GroupWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::GroupWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::GroupWidget::sClassDescription(
	"HuiTVision::GroupWidget",
	"HuiTVision::GroupWidget",
	"",
	sMethods,
	sCallbacks,
	Hui::GroupWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::ToplevelWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::ToplevelWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::ToplevelWidget::sClassDescription(
	"HuiTVision::ToplevelWidget",
	"HuiTVision::ToplevelWidget",
	"",
	sMethods,
	sCallbacks,
	Hui::ToplevelWidget::thisClassDescription(),
	HuiTVision::GroupWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::WindowWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::WindowWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::WindowWidget::sClassDescription(
	"HuiTVision::WindowWidget",
	"HuiTVision::WindowWidget",
	"",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription(),
	HuiTVision::ToplevelWidget::thisClassDescription(),
	Hui::WindowWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::DialogWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::DialogWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::DialogWidget::sClassDescription(
	"HuiTVision::DialogWidget",
	"HuiTVision::DialogWidget",
	"",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription(),
	HuiTVision::ToplevelWidget::thisClassDescription(),
	Hui::DialogWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::LabelWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::LabelWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::LabelWidget::sClassDescription(
	"HuiTVision::LabelWidget",
	"HuiTVision::LabelWidget",
	"Widget for displaying a static text",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription(),
	Hui::LabelWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::ButtonWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::ButtonWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::ButtonWidget::sClassDescription(
	"HuiTVision::ButtonWidget",
	"HuiTVision::ButtonWidget",
	"Push button with a text",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription(),
	Hui::ButtonWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::TitledWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::TitledWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::TitledWidget::sClassDescription(
	"HuiTVision::TitledWidget",
	"HuiTVision::TitledWidget",
	"Base class for widgets having label",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::InputLineWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::InputLineWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::InputLineWidget::sClassDescription(
	"HuiTVision::InputLineWidget",
	"HuiTVision::InputLineWidget",
	"Simple line editor for inputting text with some validation",
	sMethods,
	sCallbacks,
	HuiTVision::TitledWidget::thisClassDescription(),
	Hui::InputLineWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::ButtonsGroupWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::ButtonsGroupWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::ButtonsGroupWidget::sClassDescription(
	"HuiTVision::ButtonsGroupWidget",
	"HuiTVision::ButtonsGroupWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription(),
	Hui::ButtonsGroupWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::CheckBoxesWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::CheckBoxesWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::CheckBoxesWidget::sClassDescription(
	"HuiTVision::CheckBoxesWidget",
	"HuiTVision::CheckBoxesWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiTVision::ButtonsGroupWidget::thisClassDescription(),
	Hui::CheckBoxesWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::RadioMenuWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::RadioMenuWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::RadioMenuWidget::sClassDescription(
	"HuiTVision::RadioMenuWidget",
	"HuiTVision::RadioMenuWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiTVision::ButtonsGroupWidget::thisClassDescription(),
	Hui::RadioMenuWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::ListBoxWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::ListBoxWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::ListBoxWidget::sClassDescription(
	"HuiTVision::ListBoxWidget",
	"HuiTVision::ListBoxWidget",
	"Group of non-exclusive check boxes",
	sMethods,
	sCallbacks,
	HuiTVision::TitledWidget::thisClassDescription(),
	Hui::ListBoxWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::TextEditWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::TextEditWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::TextEditWidget::sClassDescription(
	"HuiTVision::TextEditWidget",
	"HuiTVision::TextEditWidget",
	"Simple editor for inputting text",
	sMethods,
	sCallbacks,
	HuiTVision::TitledWidget::thisClassDescription(),
	Hui::TextEditWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::ProgressIndicatorWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::ProgressIndicatorWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::ProgressIndicatorWidget::sClassDescription(
	"HuiTVision::ProgressIndicatorWidget",
	"HuiTVision::ProgressIndicatorWidget",
	"Horizontal progress bar",
	sMethods,
	sCallbacks,
	HuiTVision::TitledWidget::thisClassDescription(),
	Hui::ProgressIndicatorWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::MenuItemWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::MenuItemWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::MenuItemWidget::sClassDescription(
	"HuiTVision::MenuItemWidget",
	"HuiTVision::MenuItemWidget",
	"Menu Item base class",
	sMethods,
	sCallbacks,
	HuiTVision::Widget::thisClassDescription(),
	Hui::MenuItemWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::MenuSeparatorWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::MenuSeparatorWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::MenuSeparatorWidget::sClassDescription(
	"HuiTVision::MenuSeparatorWidget",
	"HuiTVision::MenuSeparatorWidget",
	"Menu Separator",
	sMethods,
	sCallbacks,
	HuiTVision::MenuItemWidget::thisClassDescription(),
	Hui::MenuSeparatorWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::MenuButtonWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::MenuButtonWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::MenuButtonWidget::sClassDescription(
	"HuiTVision::MenuButtonWidget",
	"HuiTVision::MenuButtonWidget",
	"Menu Button",
	sMethods,
	sCallbacks,
	HuiTVision::MenuItemWidget::thisClassDescription(),
	Hui::MenuButtonWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::MenuSubmenuWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::MenuSubmenuWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::MenuSubmenuWidget::sClassDescription(
	"HuiTVision::MenuSubmenuWidget",
	"HuiTVision::MenuSubmenuWidget",
	"Menu Submenu",
	sMethods,
	sCallbacks,
	HuiTVision::MenuItemWidget::thisClassDescription(),
	Hui::MenuSubmenuWidget::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription HuiTVision::MenuBarWidget::sMethods[] =
{
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription HuiTVision::MenuBarWidget::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription HuiTVision::MenuBarWidget::sClassDescription(
	"HuiTVision::MenuBarWidget",
	"HuiTVision::MenuBarWidget",
	"Menu Bar",
	sMethods,
	sCallbacks,
	HuiTVision::MenuSubmenuWidget::thisClassDescription()
);

//======================================================================
