/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/sysinstall/FeaturesProvided.cd.cc,v 1.2 2001/06/22 15:05:15 alex Exp $
 */

// -*- C++ -*-   Thu Jan 14 1999
// Eugene Skepner <eu@qub.com>
// $Id: FeaturesProvided.cd.cc,v 1.1 1999/01/14 21:48:34 eugene Exp $

#ifndef FeaturesProvided_hh
#include "FeaturesProvided.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription FeaturesProvided::sMethods[] =
{
     MethodDescription( "FeaturesProvided", "instance",
                        LanguageInterface::Object::MethodDescription::fStatic,
                        "Returns FeaturesProvided object",
                        MethodDescription::Value( MethodDescription::vtObject, "FeaturesProvided" ),  MethodDescription::vtVoid ),
     MethodDescription( "find_and_install_features", "find_and_install_features",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Tries to find packages providing features specified and install them. Returns number of packages installed.",
                        MethodDescription::vtUInt, MethodDescription::Value( MethodDescription::vtObject, "Database", 0, "database" ), MethodDescription::Value( MethodDescription::vtListRef, "FeatureList", 0, "features" ), MethodDescription::Value( MethodDescription::vtObject, "ProgressIndicatorStack", "Pointer<ProgressIndicatorStack>()", "progress_indicator_stack" ) ),
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription FeaturesProvided::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription FeaturesProvided::sClassDescription(
     "FeaturesProvided", "FeaturesProvided",
     "FeaturesProvided interface",
     sMethods,
     sCallbacks
);

//======================================================================
