/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/sysinstall/PackageCreator.cd.cc,v 1.5 2001/07/17 18:27:53 alex Exp $
 */

// -*- C++ -*-   Mon Dec 28 1998
// Eugene Skepner <eu@qub.com>
// $Id: PackageCreator.cd.cc,v 1.2 1998/12/29 22:38:18 eugene Exp $

#ifndef PackageCreator_hh
#include "PackageCreator.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription PackageCreator::sMethods[] =
{
	MethodDescription("PackageCreator", "make",
			  LanguageInterface::Object::MethodDescription::fStatic
			  | LanguageInterface::Object::MethodDescription::fSafeExecution,
			  "Returns PackageCreator object",
			  MethodDescription::Value(MethodDescription::vtObject,
						    "PackageCreator"),
			  MethodDescription::Value(MethodDescription::vtString,
						   0,
						   0,
						   "package_name"),
			  MethodDescription::Value(MethodDescription::vtString,
						   0,
						   0,
						   "dir_to_write_package_to"),
			  MethodDescription::Value(MethodDescription::vtString,
						   0,
						   0,
						   "package_files_dir"),
			  MethodDescription::Value(MethodDescription::vtListPtr,
						   "Container<list<string> >",
						   "Pointer<Container<list<string> > >()",
						   "names_to_ignore")),
	MethodDescription("generate", "generate",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Generates absent proc in SYSINSTALL directory of the package source tree.",
			  MethodDescription::vtVoid,
			  MethodDescription::vtVoid),
	MethodDescription("write_package_file", "write_package_file",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Writes the package file.",
			  MethodDescription::vtVoid,
			  MethodDescription::vtVoid),
	MethodDescription("name", "name",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Returns package name.",
			  MethodDescription::vtString, MethodDescription::vtVoid ),
	MethodDescription("dir", "dir",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Returns directory where files for package are located.",
			  MethodDescription::vtString, MethodDescription::vtVoid),
	MethodDescription("packagedir", "packagedir",
			  LanguageInterface::Object::MethodDescription::fDynamic,
			  "Returns directory name where package file (.pkg.zip) will be written.",
			  MethodDescription::vtString, MethodDescription::vtVoid),
	MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageCreator::sCallbacks[] =
{
	CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageCreator::sClassDescription(
	"PackageCreator", "PackageCreator",
	"",
	sMethods,
	sCallbacks
);

//======================================================================
