/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/sysinstall/PackageDescription.cd.cc,v 1.2 2001/06/22 15:05:16 alex Exp $
 */

// -*- C++ -*-   Fri Dec 25 1998
// Eugene Skepner <eu@qub.com>
// $Id: PackageDescription.cd.cc,v 1.1 1998/12/25 18:36:36 eugene Exp $

#ifndef PackageDescription_hh
#include "PackageDescription.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription PackageDescription::sMethods[] =
{
     MethodDescription( "summary", "summary",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package summary",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "description", "description",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package description",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "author", "author",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package author",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "canonical_name", "canonical_name",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package canonical name",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "references", "references",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package references list",
                        MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamReferenceList" ), MethodDescription::vtVoid ),
     MethodDescription( "PackageDescription", "make",
                        LanguageInterface::Object::MethodDescription::fStatic,
                        "Returns newly created PackageDescription object",
                        MethodDescription::Value( MethodDescription::vtObject, "PackageDescription" ), MethodDescription::Value( MethodDescription::vtString, 0, 0, "summary" ), MethodDescription::Value( MethodDescription::vtString, 0, 0, "description" ), MethodDescription::Value( MethodDescription::vtString, 0, 0, "author" ), MethodDescription::Value( MethodDescription::vtString, 0, "string()", "canonical_name" ), MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamReferenceList", "new PackageStreamReferenceList", "references" ) ),
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageDescription::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageDescription::sClassDescription(
     "PackageDescription", "PackageDescription",
     "Package Description",
     sMethods,
     sCallbacks
);

//======================================================================
