/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/sysinstall/PackageFile.cd.cc,v 1.2 2001/06/22 15:05:17 alex Exp $
 */

// -*- C++ -*-   Fri Dec 25 1998
// Eugene Skepner <eu@qub.com>
// $Id: PackageFile.cd.cc,v 1.2 1999/01/10 19:02:00 eugene Exp $

#ifndef PackageFile_hh
#include "PackageFile.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription PackageFile::sMethods[] =
{
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageFile::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageFile::sClassDescription(
     "PackageFile", "PackageFile",
     "Package file access",
     sMethods,
     sCallbacks,
     FileInfo::thisClassDescription()
);

//======================================================================

LanguageInterface::Object::MethodDescription PackageFile::Difference::sMethods[] =
{
     MethodDescription( "description", "description",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns list of three strings describing single difference between database record for the package file and this file on disk: element name, new value, old value.",
                        MethodDescription::Value( MethodDescription::vtListPtr, "Container<list<string> >" ),
                        MethodDescription::vtVoid ),
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageFile::Difference::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageFile::Difference::sClassDescription(
     "PackageFile::Difference", "PackageFile::Difference",
     "Package file difference access",
     sMethods,
     sCallbacks
);

//======================================================================

LanguageInterface::Object::MethodDescription PackageFile::Consistency::sMethods[] =
{
     MethodDescription( "differences", "differences",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns list of differences between database record for the package file and this file on disk.",
                        MethodDescription::Value( MethodDescription::vtListPtr, "PackageFile::DifferenceList" ),
                        MethodDescription::vtVoid ),
     MethodDescription( "file", "file",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package file.",
                        MethodDescription::Value( MethodDescription::vtObject, "PackageFile" ),
                        MethodDescription::vtVoid ),
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageFile::Consistency::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageFile::Consistency::sClassDescription(
     "PackageFile::Consistency", "PackageFile::Consistency",
     "Package file Consistency access",
     sMethods,
     sCallbacks
);

//======================================================================
