/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/sysinstall/PackageStreamStructure.cd.cc,v 1.2 2001/06/22 15:05:18 alex Exp $
 */

// -*- C++ -*-   Sat Dec 26 1998
// Eugene Skepner <eu@qub.com>
// $Id: PackageStreamStructure.cd.cc,v 1.2 1998/12/31 13:31:21 eugene Exp $

#ifndef PackageStreamStructure_hh
#include "PackageStreamStructure.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription PackageStreamStructure::sMethods[] =
{
     MethodDescription( "prefix", "default_prefix",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package default prefix",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "files", "files",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package files list",
                        MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamFileList" ), MethodDescription::vtVoid ),
     MethodDescription( "has_subpackages", "has_subpackages",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns number of subpackages",
                        MethodDescription::vtUInt, MethodDescription::vtVoid ),
     MethodDescription( "subpackages", "subpackages",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package subpackages list",
                        MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamSubpackageList" ), MethodDescription::vtVoid ),
     MethodDescription( "has_references", "has_references",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns number of references",
                        MethodDescription::vtUInt, MethodDescription::vtVoid ),
     MethodDescription( "references", "references",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns package references list",
                        MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamReferenceList" ), MethodDescription::vtVoid ),
     MethodDescription( "check", "check_integrity",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns if integrity of the object is correct",
                        MethodDescription::vtBool, MethodDescription::vtVoid ),
     MethodDescription( "PackageStreamStructure", "make",
                        LanguageInterface::Object::MethodDescription::fStatic,
                        "Returns newly created PackageStreamStructure object",
                        MethodDescription::Value( MethodDescription::vtObject, "PackageStreamStructure" ), MethodDescription::Value( MethodDescription::vtString, 0, 0, "prefix" ), MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamFileList", 0, "files" ), MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamSubpackageList", 0, "subpackages" ), MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamReferenceList", 0, "references" ) ),
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageStreamStructure::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageStreamStructure::sClassDescription(
     "PackageStreamStructure", "PackageStreamStructure",
     "",
     sMethods,
     sCallbacks
);

//======================================================================
