/*-
 * Copyright (c) 1998-2001 The FreeBSD Project
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE FREEBSD PROJECT ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FREEBSD PROJECT OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;  LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * The views and conclusions contained in the software and documentation
 * are those of the authors and should not be interpreted as representing
 * official policies, either expressed or implied, of the FreeBSD Project.
 *
 * $FreeBSD: libh/lib/sysinstall/PackageStreamSubpackage.cd.cc,v 1.2 2001/06/22 15:05:18 alex Exp $
 */

// -*- C++ -*-   Sat Dec 26 1998
// Eugene Skepner <eu@qub.com>
// $Id: PackageStreamSubpackage.cd.cc,v 1.1 1998/12/26 09:26:54 eugene Exp $

#ifndef PackageStreamSubpackage_hh
#include "PackageStreamSubpackage.hh"
#endif

//======================================================================

LanguageInterface::Object::MethodDescription PackageStreamSubpackage::sMethods[] =
{
     MethodDescription( "name", "name",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns subpackage name",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "description", "description",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns subpackage description",
                        MethodDescription::vtString, MethodDescription::vtVoid ),
     MethodDescription( "files", "files",
                        LanguageInterface::Object::MethodDescription::fDynamic,
                        "Returns subpackage files",
                        MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamFileList" ), MethodDescription::vtVoid ),
     MethodDescription( "PackageStreamSubpackage", "make",
                        LanguageInterface::Object::MethodDescription::fStatic,
                        "Returns newly created PackageStreamSubpackage object",
                        MethodDescription::Value( MethodDescription::vtObject, "PackageStreamSubpackage" ), MethodDescription::Value( MethodDescription::vtString, 0, 0, "name" ), MethodDescription::Value( MethodDescription::vtString, 0, 0, "description" ), MethodDescription::Value( MethodDescription::vtListPtr, "PackageStreamFileList", 0, "files" ) ),
     MethodDescription()
};

LanguageInterface::Object::CallbackDescription PackageStreamSubpackage::sCallbacks[] =
{
     CallbackDescription()
};

LanguageInterface::Object::ClassDescription PackageStreamSubpackage::sClassDescription(
     "PackageStreamSubpackage", "PackageStreamSubpackage",
     "",
     sMethods,
     sCallbacks,
     FileInfo::thisClassDescription()
);

//======================================================================
