#!/usr/bin/tclh

set H_automatic_garbage_collection 0

# ----------------------------------------------------------------------

if [info exists env(H_SHARED_LIB_VERSION)] {
    set H_SHARED_LIB_VERSION $env(H_SHARED_LIB_VERSION)
} else {
    set H_SHARED_LIB_VERSION "0"
}

if [info exists env(H_SHARED_LIB_LOCATION)] {
    set H_SHARED_LIB_LOCATION $env(H_SHARED_LIB_LOCATION)
} else {
    set H_SHARED_LIB_LOCATION "/usr/lib"
}

if {! [info exists H_libhtcl]} {
    load $H_SHARED_LIB_LOCATION/libh.so.$H_SHARED_LIB_VERSION
    load $H_SHARED_LIB_LOCATION/libhtcl.so.$H_SHARED_LIB_VERSION
}
if {! [info exists H_libhfile]} {
    load $H_SHARED_LIB_LOCATION/libhfile.so.$H_SHARED_LIB_VERSION
    load $H_SHARED_LIB_LOCATION/libhtclfile.so.$H_SHARED_LIB_VERSION
}
if {! [info exists H_libhdatabase]} {
    load $H_SHARED_LIB_LOCATION/libhdatabase.so.$H_SHARED_LIB_VERSION
}
if {! [info exists H_libhui]} {
    load $H_SHARED_LIB_LOCATION/libhui.so.$H_SHARED_LIB_VERSION
    load $H_SHARED_LIB_LOCATION/libhtclhui.so.$H_SHARED_LIB_VERSION
}
if {! [info exists H_libhsysinstall]} {
    load $H_SHARED_LIB_LOCATION/libhsysinstall.so.$H_SHARED_LIB_VERSION
    load $H_SHARED_LIB_LOCATION/libhtclsysinstall.so.$H_SHARED_LIB_VERSION
}

# ----------------------------------------------------------------------

set db [Database /tmp/sysinstall2work/db]
for {set arg 0} {$arg < $argc} {incr arg} {
    puts stderr "[lindex $argv $arg]"
    set files [$db file [lindex $argv $arg]]
    if {[llength $files] == 0} {
	puts stderr "\tNo records for the file in the database"
    } else {
	foreach file $files {
	    puts stderr "\t[$file pathname] [$file length] [H::string_time_t [$file mtime]]"
	    set packages [$db packages_owning [lindex $argv $arg]]
	    if {[llength $packages] == 0} {
		puts stderr "\t\tNot owned"
	    } else {
		foreach package $packages {
		    puts stderr "\t\t[$package name]"
		}
	    }
	}
    }
}

exit 0

# ----------------------------------------------------------------------
