#!/usr/bin/tclh

set hui_type "auto"

if {[info exists argc]} {
    if {$argc > 0} {
	set hui_type [lindex $argv 0]
    }
}

if [info exists env(H_SHARED_LIB_VERSION)] {
    set H_SHARED_LIB_VERSION $env(H_SHARED_LIB_VERSION)
} else {
    set H_SHARED_LIB_VERSION "0"
}

if [info exists env(H_SHARED_LIB_LOCATION)] {
    set H_SHARED_LIB_LOCATION $env(H_SHARED_LIB_LOCATION)
} else {
    set H_SHARED_LIB_LOCATION "/usr/lib"
}

if {! [info exists H_libhfile]} {
    load $H_SHARED_LIB_LOCATION/libhfile.so.$H_SHARED_LIB_VERSION
    load $H_SHARED_LIB_LOCATION/libhtclfile.so.$H_SHARED_LIB_VERSION
}

if {! [info exists H_libhdatabase]} {
    load $H_SHARED_LIB_LOCATION/libhdatabase.so.$H_SHARED_LIB_VERSION
}

if {! [info exists H_libhui]} {
	load $H_SHARED_LIB_LOCATION/libhui.so.$H_SHARED_LIB_VERSION
	load $H_SHARED_LIB_LOCATION/libhtclhui.so.$H_SHARED_LIB_VERSION
}

if {! [info exists H_libhsysinstall]} {
    load $H_SHARED_LIB_LOCATION/libhsysinstall.so.$H_SHARED_LIB_VERSION
    load $H_SHARED_LIB_LOCATION/libhtclsysinstall.so.$H_SHARED_LIB_VERSION
}

# ----------------------------------------------------------------------

set about_msg "FreeBSD Packages Handling Tool\n\nv. 8 1/3"

#  horizontal|vertical <name> {
#      horizontal <name> <stretch> { ... }
#      vertical <name> <stretch> { ... }
#      stretch <stretch>
#      spacing <spacing>
#      strut <spacing>
#      <widget> {<name> other widget creation args} <stretch> <alignment: center|left|right|top|bottom>
#  }

#  set dialog_desc {
#      horizontal box1 {
#  	vertical box11 1 {
#  	    button {button_widget "Sexing the ~C~herry" {button_callback "OK"} "default"} 0 center
#  	    stretch 1
#  	    button {button_widget1 "The ~P~assion" {button_callback ""} "normal"} 0 center
#  	    stretch 1
#  	    inputLine {inputLine_widget1 "creeping takeover" 100 "none" "&Interia selling"} 0 center
#  	    stretch 1
#  	    checkBoxes {checkBoxes_widget1 {~o~ne ~m~illion ~s~ouls} {1 0 0} "&W. H."} 0 center
#  	    stretch 1
#  	    radioMenu {radioMenu_widget1 {~o~ne ~m~illion ~s~ouls} 3 "W. &H."} 0 center
#  	}
#  	stretch 1
#  	vertical box12 40 {
#  	    listBox {listBox_widget1 {You are going to lose that girl} 0 "~H~elp!"} 1 center
#  	    textEdit {textEdit_widget1 "Lay your sleeping head, my love,\nHuman on my faithless arm;\nTime and fevers burn away\nIndividual beauty from\nThoughtful children, and the grave\nProves the child ephemeral:\nBut in my arm till break of day\nLet the living creature lie,\nMortal, guilty, but to me\nThe entirely beatiful" 0 "&Auden"} 1 center
#  	    progressIndicator {progressIndicator_widget1 0 1 0.3 "&Life"} 0 center
#  	}
#      }
#  }

set installed_packages_window_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    horizontal box11 1 {
		listBox {packages_names $packages_names 0 "&Packages:"} 2 center
		spacing 2
		listBox {files {} -1 "&Files:"} 3 center
	    }
	    spacing 1
	    horizontal box12 1 {
		textEdit {package_info "" 0 "&Info:"} 1 center
		spacing 1
		vertical box121 0 {
		    stretch 1
		    button {check_button "&Check" [list check_package $packages] "normal"} 0 center
		    spacing 1
		    button {uninstall_button "&Uninstall" [list uninstall_package $packages] "normal"} 0 center
		}
	    }
	}
	spacing 1
    }
}

set open_package_url_dialog_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    spacing 1
	    inputLine {opu_inputLine $initial 256 "none" "&Enter URL"} 0 center
	    stretch 1
	    horizontal box12 0 {
		stretch 1
		button {ok_button "&OK" {button_click_result OK} "default"} 1 center
		stretch 1
		button {cancel_button "&Cancel" {button_click_result CANCEL} "normal"} 1 center
		stretch 1
	    }
	    stretch 1
	}
	spacing 1
    }
}

set package_installation_dialog_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    spacing 1
	    label {package_name_label "Package: [$package_stream name]"} 0 left
	    stretch 1
	    label {package_summary_label "Summary: [[$package_stream description] summary]"} 0 left
	    stretch 1
	    label {package_description_label "Description: [[$package_stream description] description]"} 0 left
	    stretch 1
	    label {package_author_label "Author: [[$package_stream description] author]"} 0 left
	    spacing 1
	}
	spacing 1
	vertical box2 0 {
	    spacing 1
	    button {upgrade_button "&Upgrade" {button_click_result "upgrade"} "normal"} 0 center
	    spacing 1
	    button {install_button "&Install" {button_click_result "install"} "normal"} 0 center
	    stretch 1
	    button {close_button "&Close" {button_click_result "CANCEL"} "default"} 0 center
	    spacing 1
	}
	spacing 1
    }
}

set package_check_results_dialog_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    textEdit {package_problems_textview "$problems" 0 "&Package $name problems encountered:"} 1 left
	    spacing 1
	    horizontal box11 0 {
		stretch 1
		button {ok_button "&Dismiss" {button_click_result "OK"} "default"} 0 center
		stretch 1
	    }
	}
	spacing 1
    }
}

set options_dialog_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    spacing 1
	    inputLine {database_path_inputLine $path_to_db 256 "none" "&Packages:"} 0 center
	    spacing 1
	    inputLine {installation_prefix_inputLine $prefix 256 "none" "&Installation Prefix:"} 0 center
	    spacing 1
	    stretch 1
	    horizontal box11 0 {
		stretch 1
		button {ok_button "&OK" {button_click_result OK} "default"} 1 center
		stretch 1
		button {cancel_button "&Cancel" {button_click_result CANCEL} "normal"} 1 center
		stretch 1
	    }
	}
	spacing 1
    }
}

set directories_access_dialog_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    horizontal box11 1 {
		vertical box111 1 {
		    listBox {denied_listbox $denied_dirs 0 "&Denied:"} 1 center
		    spacing 1
		    horizontal box1111 0 {
			button {add_deny_button "&Add" [list directories_access_dialog_callback add_deny] "normal"} 1 center
			stretch 1
			button {edit_deny_button "&Edit" [list directories_access_dialog_callback edit_deny] "normal"} 1 center
			stretch 1
			button {remove_deny_button "&Remove" [list directories_access_dialog_callback remove_deny] "normal"} 1 center
			stretch 1
		    }
		}
		spacing 2
		vertical box112 1 {
		    listBox {allowed_listbox $allowed_dirs 0 "A&llowed:"} 1 center
		    spacing 1
		    horizontal box1121 0 {
			button {add_allow_button "A&dd" [list directories_access_dialog_callback add_allow] "normal"} 1 center
			stretch 1
			button {edit_allow_button "E&dit" [list directories_access_dialog_callback edit_allow] "normal"} 1 center
			stretch 1
			button {remove_allow_button "Re&move" [list directories_access_dialog_callback remove_allow] "normal"} 1 center
			stretch 1
		    }
		}
	    }
	    spacing 1
	    horizontal box12 0 {
		stretch 1
		button {ok_button "&OK" {button_click_result OK} "default"} 1 center
		stretch 1
		button {cancel_button "&Cancel" {button_click_result CANCEL} "normal"} 1 center
		stretch 1
	    }
	}
	spacing 1
    }
}

set directories_access_dialog_add_desc {
    horizontal box {
	spacing 1
	vertical box1 1 {
	    spacing 1
	    inputLine {directory_inputLine $initial 256 "none" "$label"} 0 center
	    stretch 1
	    horizontal box12 0 {
		stretch 1
		button {ok_button "&OK" {button_click_result OK} "default"} 1 center
		stretch 1
		button {cancel_button "&Cancel" {button_click_result CANCEL} "normal"} 1 center
		stretch 1
	    }
	}
	spacing 1
    }
}

set view_log_dialog_desc {
    vertical box {
	textEdit {log $log_text 0 "&Log:"} 1 center
  	spacing 1
	horizontal box11 0 {
	    stretch 1
	    button {ok_button "&Dismiss" {button_click_result OK} "default"} 0 center
	    stretch 1
	}
    }
}

set view_history_dialog_desc {
    vertical box {
	listBox {history $history_text 0 "&History:"} 1 center
  	spacing 1
	horizontal box11 0 {
	    stretch 1
	    button {ok_button "&Dismiss" {button_click_result OK} "default"} 0 center
	    stretch 1
	}
    }
}

# ----------------------------------------------------------------------

proc make_dialog_layout_interior {dialog box desc preset} {

    foreach arg $preset {set [lindex $arg 0] [lindex $arg 1]}

    while {[llength $desc] > 0} {
	switch -exact [lindex $desc 0] {
	    "stretch" {
		$box addStretch [lindex $desc 1]
		set desc [lreplace $desc 0 1]
	    }
	    "spacing" {
		$box addSpacing [lindex $desc 1]
		set desc [lreplace $desc 0 1]
	    }
	    "strut" {
		$box addStrut [lindex $desc 1]
		set desc [lreplace $desc 0 1]
	    }
	    "vertical" {
		set subbox [$box addVerticalBox [lindex $desc 1] [lindex $desc 2]]
		make_dialog_layout_interior $dialog $subbox [lindex $desc 3] $preset
		set desc [lreplace $desc 0 3]
		H::delete $subbox
	    }
	    "horizontal" {
		set subbox [$box addHorizontalBox [lindex $desc 1] [lindex $desc 2]]
		make_dialog_layout_interior $dialog $subbox [lindex $desc 3] $preset
		set desc [lreplace $desc 0 3]
		H::delete $subbox
	    }
	    default {
		set widget [eval $dialog [lindex $desc 0] [lindex $desc 1]]
		$box addWidget $widget [lindex $desc 2] [lindex $desc 3]
		set desc [lreplace $desc 0 3]
	    }
	}
    }
}

proc make_dialog {dialog desc preset current_name} {

    if {[llength $desc] != 3} {
	error "Invalid dialog description, list of 3 elements expected: layout_type name interior_description"
    }

    switch -exact [lindex $desc 0] {
	"horizontal" {
	    set box [$dialog horizontalBox [lindex $desc 1]]
	}
	"vertical" {
	    set box [$dialog verticalBox [lindex $desc 1]]
	}
	default {
	    error "`vertical' or `horizontal' expected as top-level layout for dialog"
	}
    }

    make_dialog_layout_interior $dialog $box [lindex $desc 2] $preset
    $dialog current [$dialog byName $current_name]
    $box activate
    H::delete $box
    return $dialog
}

# ----------------------------------------------------------------------

proc make_manubar {hui} {

    set menuBar [$hui menuBar]

    set FileMenu [$menuBar addSubmenu b1 &File "File Comment"]
    $FileMenu addButton install_menu_button "&Install/Upgrade ..." {open_package_file 0} "F3" ""
    $FileMenu addButton install_menu_button "&Install/Upgrade URL ..." {open_package_url 0} "F4" ""
    $FileMenu addButton qfm &Quit {exit_hui 0} "Alt-X" "Quit sysinstall"

    set DatabaseMenu [$menuBar addSubmenu options &Database "Database Comment"]
    $DatabaseMenu addButton history_menu_button "&History" {installation_history 0} "" ""
    $DatabaseMenu addSeparator sep
    $DatabaseMenu addButton hardware_upgrade_menu_button "&Hardware Upgrade" {hardware_upgrade 0} "" ""
    $DatabaseMenu addButton check_conflicts_menu_button "&Check Conflicts" {check_conflicts 0} "" ""
    $DatabaseMenu addButton duplicate_features_menu_button "&Find duplicate features" {find_duplicate_features 0} "" ""
    $DatabaseMenu addSeparator sep
    $DatabaseMenu addButton database_repair_menu_button "&Repair Database" {repair_database 0} "" ""

    set OptionsMenu [$menuBar addSubmenu options &Options "Options Comment"]
    $OptionsMenu addButton options_menu_button "&Options ..." {options_dialog 0} "Ctrl-O" ""
    $OptionsMenu addButton directories_access_menu_button "&Directories Access ..." {directories_access_dialog 0} "Ctrl-D" ""

    $menuBar addSeparator sep

    set HelpMenu [$menuBar addSubmenu help &Help ""]
    $HelpMenu addButton about &About {about_dialog {}} "F1" "Show about message"

}

# ----------------------------------------------------------------------

proc exit_hui {hui button exit_code} {

    $hui exit $exit_code
}

# ----------------------------------------------------------------------

proc button_click_result {hui button user_data} {
    return $user_data;
}

# ----------------------------------------------------------------------

proc create_database {hui path_to_db} {

    set db [H::null]
    set status [yes_no_dialog $hui "Create Database" "Create database in $path_to_db?"]
    if {[string compare $status "YES"] == 0} {
	if {[catch {set db [Database::create $path_to_db]} err]} {
	    message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    message_dialog $hui "Success" "Database created in $path_to_db" center {{"~D~ismiss" {button_click_result OK} "default"}}
	    set allow [[DirectoriesAccess] allow]
	    lappend allow "/tmp/sysinstall2work"
	    [DirectoriesAccess] allow $allow
	    $db save_directories_access
	}
    }
    return $db
}

proc create_or_open_database {hui path_to_db} {

    set db [H::null]
    if [catch "set db [Database $path_to_db]" err] {
	if {![H::is_null $db]} {H::delete $db}
	set db [create_database $hui $path_to_db]
    }
    return $db
}

# ----------------------------------------------------------------------

proc about_dialog {hui {button {}} {user_data {}}} {

    global about_msg
    message_dialog $hui About $about_msg center {{"~T~ake It" {button_click_result OK} "default"} {"~L~eave It" {button_click_result OK} "normal"}}
}

# ----------------------------------------------------------------------

proc yes_no_dialog {hui title message} {

    message_dialog $hui $title $message left {{"~Y~es" {button_click_result YES} "default"} {"~N~o" {button_click_result NO} "normal"}}
}

# ----------------------------------------------------------------------

proc format_message_for_dialog {hui message} {

    set max_line_length [expr [lindex [$hui size] 0] - 6]

    # Split text into array by "\n"
    set msg {}
    while {[string length $message] != 0} {
		set index [string first "\n" $message]
		set to_append ""
		if {$index == -1} {
		    set to_append $message
		    set message ""
		} else {
		    set to_append [string range $message 0 [expr $index - 1]]
		    set message [string range $message [expr $index + 1] end]
		}
		while {[string length $to_append] > $max_line_length} {
	    set index [string wordstart $to_append $max_line_length]
	    if {$index == 0} {break}
	    lappend msg [string range $to_append 0 [expr $index - 1]]
	    set to_append [string range $to_append $index end]
		}
	lappend msg $to_append
	}
    return $msg
}

# ----------------------------------------------------------------------

proc message_dialog {hui title message alignment buttons} {

    set objects_references [H::objects_references]

    set msg [format_message_for_dialog $hui $message]

    set minimum_dialog_width [expr [llength $buttons] * 4]
    if {$minimum_dialog_width < 20} {set minimum_dialog_width 20}

    set maximum_dialog_width [expr [lindex [$hui size] 0] - 2]

    set dialog_height [expr [llength $msg] + 5]
    set dialog_width 0
    foreach text $msg {
	if {[string length $text] > $dialog_width} {
	    set dialog_width [string length $text]
	}
    }

    incr dialog_width 2
    if {$dialog_width < $minimum_dialog_width} {set dialog_width $minimum_dialog_width}
    if {$dialog_width > $maximum_dialog_width} {set dialog_width $maximum_dialog_width}

    set dialog_x [expr [expr [lindex [$hui size] 0] - $dialog_width] / 2]
    set dialog_y [expr [expr [lindex [$hui size] 1] - $dialog_height] / 2]

    global main_window
    set dialog [$hui dialog $main_window message_dialog $title "$dialog_x $dialog_y" "$dialog_width $dialog_height"]

    set dialog_main_box [$dialog horizontalBox dialog_box]
    $dialog_main_box addSpacing 1
    set dialog_box [$dialog_main_box addVerticalBox dialog_box 0]
    $dialog_main_box addSpacing 1

    $dialog_box addStretch 1

    foreach text $msg {
	set label [$dialog label label $text]
	$dialog_box addWidget $label 0 $alignment
    }

    $dialog_box addStretch 1

    set buttons_box [$dialog_box addHorizontalBox buttons_box 0]

    set button_no 1
    set current_button [H::null]
    foreach button $buttons {
	set button_widget [$dialog button button [lindex $button 0] [lindex $button 1] [lindex $button 2]]
	$buttons_box addWidget $button_widget 1
	if {$button_no < [llength $buttons]} {
	    $buttons_box addStretch 2
	}
	if {$button_no == 1} {set current_button $button_widget}
	if {![string compare "default" [lindex $button 2]]} {set current_button $button_widget}
	incr button_no
    }

    $dialog_box addSpacing 1

    if {![H::is_null $current_button]} {
	$dialog current $current_button
    }

    $dialog_main_box activate
    $dialog exec
    set status [$dialog result]

    H::delete $objects_references

    return $status
}

# ----------------------------------------------------------------------

proc show_package_info {hui window package} {
    set objects_references [H::objects_references]

    set text ""

    set description [$package description]
    if {![H::is_null $description]} {
	set text [format "%s\n\nSummary:\n %s\n\nDescription:\n %s\n\nAuthor:\n %s\n\n" [$package name] [$description summary] [$description description] [$description author]]
    }

    set text "${text}Provides features:\n"
    set features [$package features]
    foreach feature $features {
	set text [format "%s %s %s %d %d\n" $text [$feature name] [$feature version] [$feature serial] [$feature snapshot]]
    }
    set text "${text}\n"

    set text "${text}Requires features:\n"
    set features [$package requires]
    foreach feature $features {
	set text [format "%s %s %s %d %d\n" $text [$feature name] [$feature version] [$feature serial] [$feature snapshot]]
    }
    set text "${text}\n"

    set text "${text}Conflicts features:\n"
    set features [$package conflicts]
    foreach feature $features {
	set text [format "%s %s %s %d %d\n" $text [$feature name] [$feature version] [$feature serial] [$feature snapshot]]
    }
    set text "${text}\n"

    [$window byName package_info] text $text

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc show_package_files {hui window package} {
    set objects_references [H::objects_references]

    set files_listbox [$window byName files]
    $files_listbox removeAll
    foreach file [$package files] {
	$files_listbox add [$files_listbox numberOfItems] [$file pathname]
    }

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc packages_names_listbox_value_changed {hui listbox id packages} {

    set package [lindex $packages $id]
    #puts stderr "packages_names_listbox_value_changed: $id [$package name]"
    global main_window
    show_package_files $hui $main_window $package
    show_package_info $hui $main_window $package

}

# ----------------------------------------------------------------------

proc packages_names_listbox_entered {hui listbox packages} {

    #set package [lindex $packages [$listbox select]]
    #puts stderr "packages_names_listbox_entered Package: [$package name]"
    #global main_window
    #show_package_info $hui $main_window $package
}

# ----------------------------------------------------------------------

proc packages_names_listbox_left {hui listbox packages} {

    #set package [lindex $packages [$listbox select]]
}

# ----------------------------------------------------------------------

proc make_installed_packages_window {hui db} {

    global main_window

    set main_window [$hui byName installed_packages_window]
    if [H::is_null $main_window] {
	if [H::is_null $db] {
	    message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    set packages [$db all_packages]

	    set packages_names {}
	    foreach package $packages {
		lappend packages_names [$package name]
	    }

	    lappend preset [list packages_names "$packages_names"] [list packages "$packages"]

	    set main_window [$hui window main_window "Installed Packages" "0 0" "80 22"]
	    global installed_packages_window_desc
	    make_dialog $main_window $installed_packages_window_desc $preset packages_names

	    [$main_window byName packages_names] onSelect [list packages_names_listbox_value_changed "$packages"]
	    [$main_window byName packages_names] onEnter [list packages_names_listbox_entered "$packages"]
	    [$main_window byName packages_names] onLeave [list packages_names_listbox_left "$packages"]
		
		if {[llength $packages] > 0} {
	    	set package [lindex $packages 0]
		    show_package_files $hui $main_window $package
		    show_package_info $hui $main_window $package
		}

	    $main_window show
	}
    }
}

# ----------------------------------------------------------------------

proc open_package_file {hui button dummy} {

    global zips_dir
    set filename [$hui fileSelectionDialog "Open Package File" "$zips_dir/*.zip"]
    if {[string length $filename] > 0} {
	if [catch {set stream [Archive::open $filename]} err ] {
	    message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    set package_stream [PackageStream::open $stream slave [ProgressIndicatorHuiStack $hui]]
	    package_installation_dialog $hui $package_stream
	    H::delete $stream
	    H::delete $package_stream
	}
    }
}

# ----------------------------------------------------------------------

proc open_package_url {hui button dummy} {

    set dialog_objects_references [H::objects_references]
    global open_package_URL_last
    lappend preset [list initial $open_package_URL_last]
    global main_window
    set dialog [$hui dialog $main_window open_package_url "Install/Upgrade" "15 6" "50 8"]
    global open_package_url_dialog_desc
    make_dialog $dialog $open_package_url_dialog_desc $preset opu_inputLine
    $dialog exec
    set status [$dialog result]
    if {[string compare $status "OK"] == 0} {
	set open_package_URL_last [[$dialog byName opu_inputLine] text]
    }
    H::delete $dialog_objects_references

    if {[string compare $status "OK"] == 0 && [string length $open_package_URL_last] > 0} {
	if [catch {set stream [Archive::open $open_package_URL_last]} err ] {
	    message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    set package_stream [PackageStream::open $stream slave [ProgressIndicatorHuiStack $hui]]
	    package_installation_dialog $hui $package_stream
	    H::delete $stream
	    H::delete $package_stream
	}
    }

}

# ----------------------------------------------------------------------

proc package_installation_dialog {hui package_stream} {
    # No set objects_references [H::objects_references]

    set dialog_objects_references [H::objects_references]
    lappend preset [list package_stream "$package_stream"]
    global main_window
    set dialog [$hui dialog $main_window package_installation_dialog "Install/Upgrade" "5 1" "70 17"]
    global package_installation_dialog_desc
    make_dialog $dialog $package_installation_dialog_desc $preset close_button
    $dialog exec
    set status [$dialog result]
    H::delete $dialog_objects_references

    switch -exact $status {
	"upgrade" {package_upgrade $hui $package_stream; reread_database $hui}
	"install" {package_install $hui $package_stream; reread_database $hui}
    }
}

# ----------------------------------------------------------------------

proc package_upgrade {hui package_stream} {
    # No set objects_references [H::objects_references]

    set status [yes_no_dialog $hui "Upgrade" "Upgrade package [$package_stream name]?"]
    if {[string compare $status "YES"] == 0} {
	global db
	if [H::is_null $db] {
	    message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    set old_log_type [Log::gettype]
	    Log::type "string"
	    if [catch {$package_stream upgrade $db} err] {
		message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	    } else {
		message_dialog $hui "Success" "Package [$package_stream name] upgraded" center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
		$db flush
	    }
	    [Log] clear
	    Log::type $old_log_type
	}
    }
}

# ----------------------------------------------------------------------

proc package_install {hui package_stream} {
    # No set objects_references [H::objects_references]

    set status [yes_no_dialog $hui "Install" "Install package [$package_stream name]?"]
    if {[string compare $status "YES"] == 0} {
	global db
	if [H::is_null $db] {
	    message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    set old_log_type [Log::gettype]
	    Log::type "string"
	    if [catch {$package_stream install $db} err] {
		message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	    } else {
		message_dialog $hui "Success" "Package [$package_stream name] installed" center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
		$db flush
	    }
	    [Log] clear
	    Log::type $old_log_type
	}
    }
}

# ----------------------------------------------------------------------

proc reread_database {hui} {

    # No H::delete $objects_references

    global db
    if [H::is_null $db] {
	message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
    } else {
	global main_window
	set packages_names_listbox [$main_window byName packages_names]
	set itemno [$packages_names_listbox select]
	$packages_names_listbox onSelect {}
	$packages_names_listbox onEnter {}
	$packages_names_listbox onLeave {}
	$packages_names_listbox removeAll

	set packages [$db all_packages]
	foreach package $packages {
	    $packages_names_listbox add [$packages_names_listbox numberOfItems] [$package name]
	}
	$packages_names_listbox onSelect [list packages_names_listbox_value_changed "$packages"]
	$packages_names_listbox onEnter [list packages_names_listbox_entered "$packages"]
	$packages_names_listbox onLeave [list packages_names_listbox_left "$packages"]

	[$main_window byName uninstall_button] onClick [list uninstall_package "$packages"]
	[$main_window byName check_button] onClick [list check_package "$packages"]

	if {[$packages_names_listbox numberOfItems] > $itemno} {
	    $packages_names_listbox select $itemno
	} else {
	    $packages_names_listbox select 0
	}
	set package [lindex $packages [$packages_names_listbox select]]
	show_package_files $hui $main_window $package
	show_package_info $hui $main_window $package
    }
}

# ----------------------------------------------------------------------

proc uninstall_package {hui button packages} {

    global main_window
    set packages_names_listbox [$main_window byName packages_names]
    set package [lindex $packages [$packages_names_listbox select]]
    $package progress_indicator_stack [ProgressIndicatorHuiStack $hui]

    global db
    set name [$package name]

    set status [yes_no_dialog $hui "Uninstall" "Uninstall package $name?"]
    if {[string compare $status "YES"] == 0} {
	set old_log_type [Log::gettype]
	Log::type "string"
	if {[catch {$package uninstall} err]} {
	    message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    message_dialog $hui "Success" "Package $name uninstalled" center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    $db flush
	}
	[Log] clear
	Log::type $old_log_type
	reread_database $hui
    }
}

# ----------------------------------------------------------------------

proc check_package {hui button packages} {

    global main_window
    set packages_names_listbox [$main_window byName packages_names]
    set package [lindex $packages [$packages_names_listbox select]]

    set objects_references [H::objects_references]
    set check_result [$package consistency_check]
    if {[llength $check_result] > 0} {
	set problems ""
	for {set f 0} {$f < [llength $check_result]} {incr f} {
	    set consitency [lindex $check_result $f]
	    set fd [$consitency differences]
	    set problems "$problems[[$consitency file] pathname]\n"
	    foreach difference $fd {
		set problem [$difference description]
		set problem_type [lindex $problem 0]
		switch -exact $problem_type {
		    "absent" {set text "File is absent"}
		    "permissions-denied" {set text "Unable to get information about file: permissions denied"}
		    "unknown-problem" {set text "Unable to get information about file: unknown problem"}
		    "mtime" {set text "File modification time changed: [H::string_time_t [lindex $problem 1]] (was: [H::string_time_t [lindex $problem 2]])"}
		    default {set text "$problem_type: [lindex $problem 1] (was: [lindex $problem 2])"}
		}
		set problems "$problems   $text\n"
	    }
	}

	lappend preset [list name [$package name]] [list problems $problems]
	global main_window
	set dialog [$hui dialog $main_window package_check_results_dialog "Package Check" "5 1" "70 17"]
	global package_check_results_dialog_desc
	make_dialog $dialog $package_check_results_dialog_desc $preset package_problems_textview
	$dialog exec
	set status [$dialog result]
    } else {
	message_dialog $hui "Package Check" "Package [$package name]\nNo problems encountered." center {{"~D~ismiss" {button_click_result OK} "default"}}
    }
    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc options_dialog {hui button dummy} {
    set objects_references [H::objects_references]

    global path_to_db
    lappend preset [list path_to_db "$path_to_db"] [list prefix "[[Configuration] prefix]"]
    global main_window
    set dialog [$hui dialog $main_window options_dialog "Options" "10 4" "60 12"]
    global options_dialog_desc
    make_dialog $dialog $options_dialog_desc $preset database_path_inputLine
    $dialog exec
    set status [$dialog result]

    if {[string compare $status "OK"] == 0} {
	set path_to_db_inputline [$dialog byName database_path_inputLine]
	global db
  	if {[H::is_null $db] || [string compare $path_to_db [$path_to_db_inputline text]]} {
#  	    set installed_packages_window_existed 0
#  	    set installed_packages_window [$hui byName installed_packages_window]
#  	    if {! [is_null $installed_packages_window]} {
#  		set installed_packages_window_existed 1
#  		$hui remove $installed_packages_window
#  		delete $installed_packages_window
#  	    }
#    	    set path_to_db [$path_to_db_inputline text]
#    	    open_database $hui
#  	    if {![is_null $db] && $installed_packages_window_existed} {
#  		insert_installed_packages_window $hui
#  	    }
  	}

  	[Configuration] prefix [[$dialog byName installation_prefix_inputLine] text]
    }

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc directories_access_dialog {hui button dummy} {
    set objects_references [H::objects_references]

    lappend preset [list denied_dirs [[DirectoriesAccess] deny]] [list allowed_dirs [[DirectoriesAccess] allow]]
    global main_window
    set dialog [$hui dialog $main_window directories_access_dialog "Access To Directories" "5 1" "70 17"]
    global directories_access_dialog_desc
    make_dialog $dialog $directories_access_dialog_desc $preset denied_listbox

    set listbox [$dialog byName denied_listbox]
    if {[$listbox numberOfItems] == 0} {
	[$dialog byName remove_deny_button] disable
	[$dialog byName edit_deny_button] disable
    }

    set listbox [$dialog byName allowed_listbox]
    if {[$listbox numberOfItems] == 0} {
	[$dialog byName remove_allow_button] disable
	[$dialog byName edit_allow_button] disable
    }

    $dialog exec
    set status [$dialog result]

    if {[string compare $status "OK"] == 0} {
	set listbox [$dialog byName denied_listbox]
	set deny_list {}
	for {set i 0} {$i < [$listbox numberOfItems]} {incr i} {lappend deny_list [$listbox text $i]}
	[DirectoriesAccess] deny "$deny_list"

	set listbox [$dialog byName allowed_listbox]
	set allow_list {}
	for {set i 0} {$i < [$listbox numberOfItems]} {incr i} {lappend allow_list [$listbox text $i]}
	[DirectoriesAccess] allow "$allow_list"

	global db
	$db save_directories_access
    }

    H::delete $objects_references
}

proc directories_access_dialog_callback {hui button value} {

    set dialog [$hui byName directories_access_dialog]

    global directories_access_dialog_add_desc

    switch -exact $value {
	add_deny {
	    set listbox [$dialog byName denied_listbox]
	    set dialog_objects_references [H::objects_references]
	    lappend preset [list label "Directory"] [list initial ""]
	    set dialog1 [$hui dialog $dialog directories_access_dialog_add "Add Denied Directory" "15 8" "50 8"]
	    make_dialog $dialog1 $directories_access_dialog_add_desc $preset directory_inputLine
	    $dialog1 exec
	    set status [$dialog1 result]
	    set input_line [$dialog1 byName directory_inputLine]
	    if {[string compare $status "OK"] == 0 && [string length [$input_line text]] > 0} {
		$listbox add [$listbox numberOfItems] [$input_line text]
	    }
	    H::delete $dialog_objects_references
  	    if {[$listbox numberOfItems] > 0} {
  		[$dialog byName remove_deny_button] enable
  		[$dialog byName edit_deny_button] enable
  	    }
	}
	edit_deny {
	    set listbox [$dialog byName denied_listbox]
	    if {[$listbox numberOfItems] > 0} {
		lappend preset [list label "Directory"] [list initial [$listbox text [$listbox select]]]
		set dialog_objects_references [H::objects_references]
		set dialog1 [$hui dialog $dialog directories_access_dialog_add "Edit Denied Directory" "15 8" "50 8"]
		make_dialog $dialog1 $directories_access_dialog_add_desc $preset directory_inputLine
		$dialog1 exec
		set status [$dialog1 result]
		set input_line [$dialog1 byName directory_inputLine]
		if {[string compare $status "OK"] == 0 && [string length [$input_line text]] > 0} {
		    $listbox text [$listbox select] [$input_line text]
		}
	    }
	    H::delete $dialog_objects_references
	}
	remove_deny {
	    set listbox [$dialog byName denied_listbox]
	    if {[$listbox numberOfItems] > 0} {
		$listbox remove [$listbox select]
	    }
	    if {[$listbox numberOfItems] == 0} {
		[$dialog byName remove_deny_button] disable
		[$dialog byName edit_deny_button] disable
	    }
	}
	add_allow {
	    set listbox [$dialog byName allowed_listbox]
	    lappend preset [list label "Directory"] [list initial ""]
	    set dialog_objects_references [H::objects_references]
	    set dialog1 [$hui dialog $dialog directories_access_dialog_add "Add Allowed Directory" "15 8" "50 8"]
	    make_dialog $dialog1 $directories_access_dialog_add_desc $preset directory_inputLine
	    $dialog1 exec
	    set status [$dialog1 result]
	    set input_line [$dialog1 byName directory_inputLine]
	    if {[string compare $status "OK"] == 0 && [string length [$input_line text]] > 0} {
		$listbox add [$listbox numberOfItems] [$input_line text]
	    }
	    H::delete $dialog_objects_references

	    if {[$listbox numberOfItems] > 0} {
		[$dialog byName remove_allow_button] enable
		[$dialog byName edit_allow_button] enable
	    }
	}
	edit_allow {
	    set listbox [$dialog byName allowed_listbox]
	    if {[$listbox numberOfItems] > 0} {
		lappend preset [list label "Directory"] [list initial [$listbox text [$listbox select]]]
		set dialog_objects_references [H::objects_references]
		set dialog1 [$hui dialog $dialog directories_access_dialog_add "Edit Allowed Directory" "15 8" "50 8"]
		make_dialog $dialog1 $directories_access_dialog_add_desc $preset directory_inputLine
		$dialog1 exec
		set status [$dialog1 result]
		set input_line [$dialog1 byName directory_inputLine]
		if {[string compare $status "OK"] == 0 && [string length [$input_line text]] > 0} {
		    $listbox text [$listbox select] [$input_line text]
		}
		H::delete $dialog_objects_references
	    }
	}
	remove_allow {
	    set listbox [$dialog byName allowed_listbox]
	    if {[$listbox numberOfItems] > 0} {
		$listbox remove [$listbox select]
	    }
	    if {[$listbox numberOfItems] == 0} {
		[$dialog byName remove_allow_button] disable
		[$dialog byName edit_allow_button] disable
	    }
	}
	default { return "directories_access_dialog_callback: unknown value: $value" }
    }
    return ""
}

# ----------------------------------------------------------------------

proc repair_database {hui button dummy} {
    set objects_references [H::objects_references]

    global db
    if {[H::is_null $db]} {
	message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
    } else {
	set old_log_type [Log::gettype]
	Log::type "string"
	if [catch {$db repair} err] {
	    message_dialog $hui "Error" "$err" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    message_dialog $hui "Success" "Database repaired                     " center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	}
	[Log] clear
	Log::type $old_log_type
    }

    H::delete $objects_references
    reread_database $hui
}

# ----------------------------------------------------------------------

proc hardware_upgrade {hui button dummy} {
    set objects_references [H::objects_references]

    global db
    if {[H::is_null $db]} {
	message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
    } else {
	set old_log_type [Log::gettype]
	Log::type "string"
	if [catch {$db hardware_upgrade} result] {
	    message_dialog $hui "Error" "$result" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    if {[llength $result] == 0 } {
		message_dialog $hui "Success" "No packages are conflicting with the current platform" center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    } else {
		set msg "The following packages are conflicting with the current platform:"
		foreach package $result {set msg "$msg\n[$package name]"}
		message_dialog $hui "Problematic packages" $msg center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    }
	}
	[Log] clear
	Log::type $old_log_type
    }

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc installation_history {hui button dummy} {
    set objects_references [H::objects_references]

    global db
    if {[H::is_null $db]} {
	message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
    } else {
	global main_window
	set dialog [$hui dialog $main_window view_history_dialog "History" "10 2" "60 14"]
	set hist_list [$db history]
	set history_text {}
	foreach entry $hist_list {
	    lappend history_text [format "%s | %4.4s | %s" [H::string_time_t [$entry time]] [$entry type] [$entry name]]
	}
	lappend preset [list history_text $history_text]
	global view_history_dialog_desc
	make_dialog $dialog $view_history_dialog_desc $preset history
	$dialog exec
    }

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc check_conflicts {hui button dummy} {
    set objects_references [H::objects_references]

    global db
    if {[H::is_null $db]} {
	message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
    } else {
	set old_log_type [Log::gettype]
	Log::type "string"
	if [catch {$db check_conflicts} result] {
	    message_dialog $hui "Error" "$result" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    if {[llength $result] == 0 } {
		message_dialog $hui "Success" "There are no conflicts amoung package installed" center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    } else {
		set msg "The following packages conflict with features provided the system\nor require features not provided by the system:"
		foreach package $result {set msg "$msg\n[$package name]"}
		message_dialog $hui "Problematic packages" $msg center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    }
	}
	[Log] clear
	Log::type $old_log_type
    }

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc find_duplicate_features {hui button dummy} {
    set objects_references [H::objects_references]

    global db
    if {[H::is_null $db]} {
	message_dialog $hui "Error" "Database not opened" center {{"~D~ismiss" {button_click_result OK} "default"}}
    } else {
	set old_log_type [Log::gettype]
	Log::type "string"
	if [catch {$db check_features_duplicates} result] {
	    message_dialog $hui "Error" "$result" left {{"~D~ismiss" {button_click_result OK} "default"}}
	} else {
	    if {[llength $result] == 0 } {
		message_dialog $hui "Success" "There are no duplicated features found" center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    } else {
		set msg "The following features (different versions) are provided multiple times:"
		foreach feature $result {set msg "$msg\n[$feature print]\t\t[[$db package $feature] name]"}
		message_dialog $hui "Duplicated features" $msg center {{"~O~K" {button_click_result OK} "default"} {"~V~iew log" {view_log OK} "normal"}}
	    }
	}
	[Log] clear
	Log::type $old_log_type
    }

    H::delete $objects_references
}

# ----------------------------------------------------------------------

proc Callback::uninstall_required_features_master {interpreter_name database toUninstall requirers} {

    set requirers_names ""
    foreach requirer $requirers {set requirers_names "$requirers_names\n[$requirer name]"}
    set msg "Packages:$requirers_names\nrequire features provided by [$toUninstall name] being uninstalled.\nWould you like to continue uninstallation of [$toUninstall name]?\n(Note: packages may stop working properly of you press yes button)"
    global hui
    set result [message_dialog $hui "Warning" $msg center {{"~Y~es" {button_click_result YES} "normal"} {"~N~o" {button_click_result NO} "default"}}]
    if {[string compare $result "YES"] == 0} {
	return {}
    } else {
	return "User cancelled uninstallation"
    }
}

# ----------------------------------------------------------------------

proc Callback::reverse_conflict_master {interpreter_name database package_stream conflicting_packages} {

    set conflicting_packages_names ""
    foreach conflicting_package $conflicting_packages {set conflicting_packages_names "$conflicting_packages_names\n[$conflicting_package name]"}
    set msg "Cannot install [$package_stream name]\nbecause it provides features conflicting with packages:$conflicting_packages_names"
    global hui
    message_dialog $hui "Warning" $msg center {{"~D~ismiss" {button_click_result NO} "default"}}
    return "Conflicting packages exist"
}

# ----------------------------------------------------------------------

proc Callback::install_upgrade_master {interpreter_name database url} {

    set msg "Package located in $url provides necessary features.\nInstall it?"
    global hui
    set result [message_dialog $hui "Inforamtion" $msg center {{"~Y~es" {button_click_result YES} "default"} {"~N~o" {button_click_result NO} "normal"}}]
    if {[string compare $result "YES"] == 0} {
	return "upgrade"
    } else {
	return ""
    }
}

# ----------------------------------------------------------------------

proc Callback::exec_wanted_master {interpreter_name command} {

    set msg "Script supplied with the package wants to run command:\n$command\nRun it?"
    global hui
    set result [message_dialog $hui "Inforamtion" $msg center {{"~Y~es" {button_click_result YES} "default"} {"~N~o" {button_click_result NO} "normal"}}]
    if {[string compare $result "YES"] == 0} {
	return $command
    } else {
	return ""
    }
}

# ----------------------------------------------------------------------

proc Callback::package_requirements_not_met_master {interpreter_name database package_stream requirements conflicts users groups suggestions} {

    set msg ""
    if {[llength $requirements] > 0 && [[FeaturesProvided] find_and_install_features $database $requirements [$package_stream progress_indicator_stack]] == 0} {
	set msg "${msg}Features required but not provided by the system:\n"
	foreach requirement $requirements {set msg "${msg}[$requirement print]\n"}
    }
    if {[llength $conflicts] > 0} {
	set msg "${msg}Conflicting features provided by the system:\n"
	foreach conflict $conflicts {set msg "${msg}[$conflict print]\n"}
    }
    if {[llength $users] > 0} {
	set msg "${msg}Users accounts not present in the system:\n"
	foreach user $users {set msg "${msg}$user\n"}
    }
    if {[llength $groups] > 0} {
	set msg "${msg}Groups not present in the system:\n"
	foreach group $groups {set msg "${msg}$group\n"}
    }
    if {[string length $msg] > 0} {
	if {[llength $suggestions] > 0} {
	    set msg "${msg}Suggested features not provided by the system:\n"
	    foreach suggestion $suggestions {set msg "${msg}[$suggestion print]\n"}
	}
    }

    if {[string length $msg] > 0} {
	global hui
	set result [message_dialog $hui "Inforamtion" $msg center {{"~A~bort Installation" {button_click_result YES} "default"} {"~F~orce Installation" {button_click_result NO} "normal"}}]
	if {[string compare $result "YES"] == 0} {
	    return $msg
	} else {
	    return "ignore"
	}
    }

}

# ----------------------------------------------------------------------

proc view_log {hui button dummy} {

    set objects_references [H::objects_references]

    global main_window
    set dialog [$hui dialog $main_window view_log_dialog "Log" "10 2" "60 14"]
    lappend preset [list log_text [[Log] text]]
    global view_log_dialog_desc
    make_dialog $dialog $view_log_dialog_desc $preset log
    $dialog exec

    H::delete $objects_references

    return "";
}

# ----------------------------------------------------------------------

set path_to_db "/tmp/sysinstall2work/db"
set zips_dir "/tmp/sysinstall2work"
set main_window {}
set open_package_URL_last "/tmp/sysinstall2work/fileutils-1.1.zip"

# ----------------------------------------------------------------------

set hui [Hui::open $hui_type]
make_manubar $hui

set main_window [H::null]
#about_dialog $hui
set db [create_or_open_database $hui $path_to_db]
make_installed_packages_window $hui $db
#directories_access_dialog $hui a b

$hui run

# ----------------------------------------------------------------------
