global disks

proc disk_geometry_text {disk} {
    # XXX add size of disk in MB
    format "%d cyls/%d heads/%d sectors = %d sectors" [$disk bios_cyl] [$disk bios_hd] [$disk bios_sect] [expr [$disk bios_cyl] * [$disk bios_hd] * [$disk bios_sect]]
}

proc list_disks {listbox} {
    foreach disk_name [Disk::Disk_Names] {
	if {![string match "*cd*" $disk_name]} {
	    lappend disks [Disk $disk_name]
	    $listbox add 0 [format "%s:\t%s" $disk_name [disk_geometry_text [Disk $disk_name]]]
	}
    }
    $listbox select 0
}

proc quit_callback {hui button userdata} {
    $hui exit 0
    exit 0
}

proc fdisk_callback {hui button userdata} {
    set listbox [$hui byName "disks"]
    set disk [$listbox select]
    set diskname [$listbox text $disk]
    set diskname [string range $diskname 0 2]

    source fdisk.tcl
    fdisk $diskname
}

proc diskwizard {} {
    global main_window
    global menubar
    global hui
    global disks

    $main_window erase
    $main_window arrange "vertical"
    
    set listbox [$main_window listBox "disks" {} -1 "Available Disks"]
    set cont [$main_window container "container" "0 0" "free"]
    $cont resize "-1 2"

    set quit_button [$cont button "quit_button" "&Quit" {quit_callback ""}]
    set fdisk_button [$cont button "fdisk_button" "&FDisk" {fdisk_callback ""}]
    $quit_button resize "10 2"
    $fdisk_button resize "10 2"
    $quit_button move "0 0"
    $fdisk_button move "38 0"

    set menubar [$hui menuBar]

    $main_window arrange

    list_disks $listbox

}

# Disk whlen
# Disk paritionieren
#      fr jede Parition label editor
# label editor: bla + mountpoint
