global disks

source sliceops.tcl
source fdiskops.tcl

proc update_slices {} {
    global slices
    global activedisk

    set disk $activedisk
    set active [$slices select]
    $slices removeAll

    for {set slice [[$disk chunks] part]}\
	{![H::is_null $slice]}\
	{set slice [$slice next]} {
	    $slices add [$slices numberOfItems] [slice_info $slice]
	}

    if {[$slices numberOfItems] > $active} {
	$slices select $active
    } else {
	$slices select 0
    }
}

proc button_click_result {$hui button result} {
    return $result
}

proc ok_dialog {hui parent title text textsize} {
    set msgdialog [$hui dialog $parent "msgdialog" $title "0 0" "70 20"]

    set hcont [$msgdialog container "hcont"]
    set placehold1 [$hcont container "place1"]
    $placehold1 resize "3 -1"
    set text [$hcont label "dialogtextbox" $text]
    set placehold2 [$hcont container "place2"]
    $placehold2 resize "3 -1"

    set newwidth [expr [lindex $textsize 0] + 6]
    set newheight [expr [lindex $textsize 1] + 2]

    $msgdialog resize "$newwidth $newheight"
    $msgdialog arrange "vertical"
    $hcont arrange "horizontal"
    set cont [$msgdialog container "horizontal"]
    $cont resize "-1 2"
    $cont container "p2"
    $cont button "okbutton" "&OK" {button_click_result OK} "default"
    $cont container "p2"

    $msgdialog exec

    return [$msgdialog result]
}

proc yesno_dialog {hui parent title text textsize} {
    set msgdialog [$hui dialog $parent "msgdialog" $title "0 0" "70 20"]

    set hcont [$msgdialog container "hcont"]
    set placehold1 [$hcont container "place1"]
    $placehold1 resize "3 -1"
    set text [$hcont label "dialogtextbox" $text]
    set placehold2 [$hcont container "place2"]
    $placehold2 resize "3 -1"

    set newwidth [expr [lindex $textsize 0] + 6]
    set newheight [expr [lindex $textsize 1] + 2]

    $msgdialog resize "$newwidth $newheight"
    $msgdialog arrange "vertical"
    $hcont arrange "horizontal"
    set cont [$msgdialog container "horizontal"]
    $cont resize "-1 2"
    $cont container "p2"
    $cont button "yesbutton" "&Yes" {button_click_result YES}
    $cont button "nobutton" "&No" {button_click_result NO}
    $cont container "p2"

    $msgdialog exec

    return [$msgdialog result]
}

proc fdisk {diskname} {
    global main_window
    global menubar
    global hui
    global slices
    global dialog
    global activedisk

    set activedisk [Disk $diskname]
    set disk $activedisk
    
    set dialog [$hui dialog $main_window [format "%sfdiskdialog" $diskname] \
		    $diskname "1 0" "75 18" "vertical"]
    
    set diskgeometrylabel [$dialog label "diskgeometrylabel" \
			       [format "Disk Geometry: %s" \
				    [disk_geometry_text [Disk $diskname]]]]
    $diskgeometrylabel resize "-1 1"
    
    set slices [$dialog listBox "sliceslistbox" {} -1 \
		    "Offset\tSize(ST)\tEnd\tName\tPType\tDesc\tSubtype\tFlags"]
    set hcont1 [$dialog container "hcont" "0 0" "horizontal"]
    $hcont1 resize "-1 8"

    set vcont1 [$hcont1 container "vcont1" "0 0" "vertical"]
    $vcont1 button "entire_button" "Use &Entire Disk" {entire_disk ""}
    $vcont1 button "create_button" "&Create Slice" {create_slice ""}
    $vcont1 button "delete_button" "&Delete Slice" {delete_slice ""}
    $vcont1 button "bootable_button" "Toggle &Bootable" {toggle_bootable ""}

    set vcont2 [$hcont1 container "vcont1" "0 0" "vertical"]
    $vcont2 button "changetype_button" "Change Type" {change_type ""}
    $vcont2 button "togglesize_button" "Toggle Size Units" {toggle_size ""}
    $vcont2 button "help_button" "Help" {fdisk_help ""}

    set vcont3 [$hcont1 container "vcont2" "0 0" "vertical"]
    $vcont3 button "quit_button" "&Quit" {button_click_result QUIT}
    $vcont3 button "undo_button" "&Undo All Changes" {undo_all ""}
    $vcont3 button "write_button" "Write Changes" {write_changes ""}
 
    update_slices

    $dialog exec
}
