proc create_slice {hui button diskname} {
    global slices
    global dialog
    global activedisk

    set disk $activedisk

    set selected [$slices select]
    set slice [slice_of_disk $disk [$slices select]]
    
    if [string compare [$slice type_text] "unused"] {
	ok_dialog $hui $dialog  "Unable to create slice" \
	    "Slice is in use.\nDelete it first or move to an unused one." "30 2"
    } else {
	set type [slice_create_dialog $hui $dialog $slice]
	if [string compare $type "CANCEL"] {
	    $disk Create_Chunk [$slice offset] [lindex $type 0] [lindex $type 1]\
		[concat [$slice flags] "CHUNK_ALIGN" [lindex $type 2]]
	    update_slices
	}
    }

    return ""
}

proc delete_slice {hui button diskname} {
    global slices
    global dialog
    global activedisk

    set disk $activedisk

    set selected [$slices select]

    set slice [slice_of_disk $disk [$slices select]]
    if {![string compare [$slice type_text] "unused"]} {
	ok_dialog $hui $dialog "Unable to delete slice" \
	    "Slice is already unused!" "35 2"
    } else {
	$disk Delete_Chunk $slice
	update_slices
    }

    return ""
}

proc entire_disk {hui button diskname} {
    global slices
    global dialog
    global activedisk

    set disk $activedisk

    set result [yesno_dialog $hui $dialog "Use Entire Disk"\
		    "Do you want to allocate all the disk to use FreeBSD\nwith a true partition entry so as to remain cooperative\nwith any future possible operating systems on the drive?\n\n(See also the section about ``dangerously dedicated'' disks\nin the FreeBSD FAQ.)" "62 9"]

    if {![string compare $result "YES"]} {
	set force_all 1
    } else {
	set force_all 0
    }
    
    $disk All_FreeBSD $force_all
    update_slices
    
    return ""
}

proc toggle_bootable {hui button diskname} {
    global slices
    global dialog
    global activedisk

    set disk $activedisk
    set selected [$slices select]
    set slice [slice_of_disk $disk [$slices select]]

    set flags [$slice flags]
    set bootable_flag_index [lsearch -exact $flags "CHUNK_ACTIVE"]
    if {$bootable_flag_index >= 0} {
	set flags [lreplace $flags $bootable_flag_index $bootable_flag_index]
    } else {
	lappend flags "CHUNK_ACTIVE"
    }
    $slice flags $flags

    update_slices
}

proc undo_all {hui button diskname} {
    global slices
    global dialog
    global activedisk

    set disk $activedisk

    if {![$disk modified]} {
	ok_dialog $hui $dialog "Unable to undo" "Cannot undo because information was not\nmodified since read or written to disk." "45 2"
    } else {
	if {![string compare "YES" [yesno_dialog $hui $dialog "" "Are you SURE you want to Undo everything?" "45 2"]]} {
	    $disk undo
	    
	    [$dialog byName "diskgeometrylabel"] text\
		[format "Disk Geometry: %s" \
		     [disk_geometry_text $disk]]

	    update_slices
	}
    }

    return ""
}
