proc netsetup {} {
    global hui
    global main_window

    $main_window erase
    set back_button [$main_window button "back_button" "<- &Back" {netsetup_callback "BACK"} "normal" "15 17"]
    set next_button [$main_window button "next_button" "&Next ->" {netsetup_callback "NEXT"} "normal" "26 17"]
    set quit_button [$main_window button "quit_button" "&Quit" {quit_callback ""} "normal" "37 17"]

    $back_button resize "11 2"
    $next_button resize "11 2"
    $quit_button resize "11 2"

    global IP
    global netmask
    global broadcast
    global hostname
    global domain
    global gateway
    global DNS

    set ip_text [$main_window inputLine IP_text $IP 15 "none" "IP Address" "1 0"]
    set netmask_text [$main_window inputLine netmask_text $netmask 15 "none" "Netmask" "17 0"]

    set hostname_text [$main_window inputLine hostname_text $hostname -1 "none" "Hostname" "1 3"]
    set domain_text [$main_window inputLine domain_text $domain -1 "none" "Domain" "17 3"]

    set gateway_text [$main_window inputLine gateway_text $gateway 15 "none" "Gateway" "1 6"]
    set dns_text [$main_window inputLine dns_text $DNS 15 "none" "Primary DNS Server" "17 6"]

    set broadcast_text [$main_window inputLine broadcast_text $broadcast 15 "none" "Broadcast" "1 9"]

    $ip_text resize "15 2"
    $netmask_text resize "15 2"
    $hostname_text resize "15 2"
    $domain_text resize "15 2"
    $gateway_text resize "15 2"
    $dns_text resize "15 2"
    $broadcast_text resize "15 2"

    $hui run
}

proc netsetup_callback {hui button user_data} {
    global IP
    global netmask
    global broadcast
    global hostname
    global domain
    global gateway
    global DNS
    global functionslist
    global functionptr

   switch -exact $user_data {
	"NEXT" {
	    # save new values
	    set IP        [ [$hui byName "IP_text"] text]
	    set netmask   [ [$hui byName "netmask_text"] text]
	    set hostname  [ [$hui byName "hostname_text"] text]
	    set domain    [ [$hui byName "domain_text"] text]
	    set gateway   [ [$hui byName "gateway_text"] text]
	    set DNS       [ [$hui byName "dns_text"] text]
	    set broadcast [ [$hui byName "broadcast_text"] text]
	    puts "Should now run ifconfig inet $IP netmask $netmask"
	    puts "Should now run route delete default ; route add default -host $gateway"
	    puts "Should now save hostname $hostname.$domain"
	    puts "Should now save DNS $DNS to resolv.conf"
	    incr functionptr
	    eval [lindex $functionslist $functionptr]

	}
       "BACK" {
	   set functionptr [expr $functionptr - 1]
	   eval [lindex $functionslist $functionptr]
       }
    }

    return $user_data
}