# $FreeBSD: libh/release/scripts/setup.tcl,v 1.3 2001/04/24 21:04:20 alex Exp $

set hui_type "auto"

# Init UI
puts stderr "setup.tcl: Opening hui"
set hui [Hui::open $hui_type]

proc next_callback {hui button user_data} {
    global functionslist
    global functionptr

    source instmethod.tcl
    lappend functionslist "instmethod"

    incr functionptr
    instmethod
}

proc quit_callback {hui button user_data} {
    exit 0
}

# Create the main-window and its elements
proc make_main_win {} {
    global main_window
    global hui
    
    # Create a main_window with title, x/y offset and x/y size
    set main_window [$hui window main_window "FreeBSD Setup" "14 0" "50 20"] 
    set welcometext [$main_window textEdit welcometext "Welcome to FreeBSD!

This program will guide you through the
installation of FreeBSD.

foo bar baz

Please press 'Next' to receive the next files
and continue with the installation,
or 'Quit' to quit setup of FreeBSD." FALSE]

    set next_button [$main_window button "inst_button" "&Next ->" {next_callback ""}]
    set quit_button [$main_window button "uninst_button" "&Quit" {quit_callback ""}]
    
    $welcometext resize "48 17"
    $quit_button resize "11 2"
    $next_button move "26 17"
    $quit_button move "37 17"
    $next_button resize "11 2"
    
    # Finally, show the window
    $main_window show
    
}

source commonvars.tcl

# Create the main-window
make_main_win

# Run hui
$hui run
